using System.Xml;
using System.Net;
using System.IO;
using System.Collections.Generic;

/// <summary>
/// Trida pouzita pouze pro nacteni Teplomeru z WEBu
/// Pouijte metody getTeplomerNames() a getTeplomerbyName(string teplomerName)
/// </summary>
public class Teplomery
{
  public static XmlDocument GetTeplomeryXml()
  {
    try
    {
      XmlDocument doc = new XmlDocument();

      HttpWebRequest webRequest = (HttpWebRequest)WebRequest.Create("http://teplomer.altairis.cz/GetRss.ashx");
      webRequest.Timeout = 6000;
      HttpWebResponse webResponse = (HttpWebResponse)webRequest.GetResponse();
      Stream responseStream = webResponse.GetResponseStream();
      XmlTextReader responseReader = new XmlTextReader(responseStream);

      doc.Load(responseReader);
      responseReader.Close();
      return doc;
    }
    catch
    {
      return new XmlDocument();

    }
  }

  public static List<string> GetTeplomerNames()
  {
    XmlDocument doc = GetTeplomeryXml();
    XmlNodeList xmLitems = doc.GetElementsByTagName("item");
    List<string> seznamTeplomeru = new List<string>();

    foreach (XmlNode teplomer in xmLitems)
    {
      for (int i = 0; i < teplomer.ChildNodes.Count; i++)
      {
        if (teplomer.ChildNodes[i].Name == "tm:sensorName") seznamTeplomeru.Add(teplomer.ChildNodes[i].InnerText);
      }
    }
    return seznamTeplomeru;
  }

  public static Teplomer GetTeplomerbyName(string teplomerName)
  {
    XmlDocument doc = GetTeplomeryXml();
    XmlNodeList xmLitems = doc.GetElementsByTagName("item");
    Teplomer vybranyteplomer = new Teplomer(teplomerName, "not set", "0");

    foreach (XmlNode teplomer in xmLitems)
    {
      if (teplomer.ChildNodes[4].InnerText == teplomerName)
      {
        vybranyteplomer = new Teplomer(teplomerName, teplomer.ChildNodes[5].InnerText, teplomer.ChildNodes[8].InnerText);
      }
    }
    return vybranyteplomer;
  }
}
